# coding: utf-8

"""
    TKG Kubernetes API

    This API provides to vCD tenants the means to provision (create and update) Tanzu Kubernetes Grid clusters. This is complementary to the defined-entity APIs:    GET /cloudapi/1.0.0/entities/urn:vcloud:entity:vmware.tkgcluster:1.0.0:{id} which allows to retrieve the clusters created by the API presented here. This is why you will not find here a GET operation for the corresponding entity.   # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from container_service_extension.client.tkgclient.models.tkg_cluster_spec_settings_network import TkgClusterSpecSettingsNetwork  # noqa: F401,E501
from container_service_extension.client.tkgclient.models.tkg_cluster_spec_settings_storage import TkgClusterSpecSettingsStorage  # noqa: F401,E501


class TkgClusterSpecSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'network': 'TkgClusterSpecSettingsNetwork',
        'storage': 'TkgClusterSpecSettingsStorage'
    }

    attribute_map = {
        'network': 'network',
        'storage': 'storage'
    }

    def __init__(self, network=None, storage=None):  # noqa: E501
        """TkgClusterSpecSettings - a model defined in Swagger"""  # noqa: E501

        self._network = None
        self._storage = None
        self.discriminator = None

        if network is not None:
            self.network = network
        if storage is not None:
            self.storage = storage

    @property
    def network(self):
        """Gets the network of this TkgClusterSpecSettings.  # noqa: E501


        :return: The network of this TkgClusterSpecSettings.  # noqa: E501
        :rtype: TkgClusterSpecSettingsNetwork
        """
        return self._network

    @network.setter
    def network(self, network):
        """Sets the network of this TkgClusterSpecSettings.


        :param network: The network of this TkgClusterSpecSettings.  # noqa: E501
        :type: TkgClusterSpecSettingsNetwork
        """

        self._network = network

    @property
    def storage(self):
        """Gets the storage of this TkgClusterSpecSettings.  # noqa: E501


        :return: The storage of this TkgClusterSpecSettings.  # noqa: E501
        :rtype: TkgClusterSpecSettingsStorage
        """
        return self._storage

    @storage.setter
    def storage(self, storage):
        """Sets the storage of this TkgClusterSpecSettings.


        :param storage: The storage of this TkgClusterSpecSettings.  # noqa: E501
        :type: TkgClusterSpecSettingsStorage
        """

        self._storage = storage

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TkgClusterSpecSettings):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
